﻿//
// ConsoleCSharp
//
// Copyright (c) 2020 http://www.curict.com
// This software is released under the MIT License, see LICENSE.txt.
//

using System;

namespace ConsoleCSharp
{
    class Program
    {
        static void Main(string[] args)
        {
            // decimal型 を long型 に変換
            Console.WriteLine("decimal型 を long型 に変換");
            Test1();

            // マイナス値の場合
            Console.WriteLine("");
            Console.WriteLine("マイナス値の場合");
            Test2();

            // 桁あふれする場合
            Console.WriteLine("");
            Console.WriteLine("桁あふれする場合");
            Test3();

            Console.ReadLine();
        }

        /// <summary>
        /// decimal型 を long型 に変換
        /// </summary>
        static void Test1()
        {
            decimal decimalValue = 5.1M;

            // decimal型 -> long型(少数は切り捨てされる)
            long longValue = decimal.ToInt64(decimalValue);

            // 結果は 5
            Console.WriteLine(longValue);
        }

        /// <summary>
        /// マイナス値の場合
        /// </summary>
        static void Test2()
        {
            // マイナス値の場合
            decimal decimalValue = -5.1M;
            long longValue = decimal.ToInt64(decimalValue);

            // 結果 -> -5
            Console.WriteLine(longValue);
        }

        /// <summary>
        /// 桁あふれする場合
        /// </summary>
        static void Test3()
        {
            try
            {
                // 桁あふれする場合
                decimal decimalValue = 9223372036854775807M + 1;

                // 例外(System.OverflowException)が発生する
                long longValue = decimal.ToInt64(decimalValue);
            }
            catch (Exception ex)
            {
                // 結果 -> System.OverflowException
                Console.WriteLine(ex.GetType());

                // 結果 -> Int64 型の値が大きすぎるか、または小さすぎます。
                Console.WriteLine(ex.Message);
            }
        }
    }
}
